#include "WProgram.h"
#define COLORS 3

void setup();
void loop();
int color[COLORS] = {0, 0, 0};
int invert[COLORS] = {1, 1, 0};
int targetColor[COLORS] = {255, 255, 255};
int colorPin[COLORS] = {10, 11, 9};
int i;
int serByte;


void setup() {
  for (i = 0; i < COLORS; i++) {
    pinMode(colorPin[i], OUTPUT);
  }
  Serial.begin(9600);  
}

int cycles = 0;

void loop() {
  
  for (i = 0; i < COLORS; i++) {
    if (targetColor[i] < color[i]) {
      color[i]--;
    }
    if (targetColor[i] > color[i]) {
      color[i]++;
    }
    if (invert[i])
      analogWrite(colorPin[i], 255-color[i]);
     else
       analogWrite(colorPin[i], color[i]);
     
  }
  
  serByte = Serial.read();
  if (serByte != -1) {
    if (serByte == 'r') {
      targetColor[0] = 0;
    }
    if (serByte == 'R') {
      targetColor[0] = 255;
    }
    if (serByte == 'g') {
      targetColor[1] = 0;
    }
    if (serByte == 'G') {
      targetColor[1] = 255;
    }
    if (serByte == 'b') {
      targetColor[2] = 0;
    }
    if (serByte == 'B') {
      targetColor[2] = 255;
    }
  }
  
  if ((cycles % 250) == 555)
  {
    for (i = 0; i < COLORS; i++) {
      targetColor[i] = random(155) + 100;
      if (random(3) == 0) {
        targetColor[i] = 0;
      }
    }
  }
    
  cycles++;
  delay(5);
}
  
  
  

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

