/**
 * controll programm for the RGB led 
 * copzleft by Philipp Tiewfenbacher
 */

import processing.serial.*;


int colors = 3;
int mode_sin = 1;
int mode_sin2 = 2;

float val;
int modes[];
float angles[];
color cols[];
HScrollbar Values[];
HScrollbar Frequ[];

Serial port;


void setup()
{
  size(550, 170);
  
  
  
  // Print a list in case COM1 doesn't work out
  println("Available serial ports:");
  println(Serial.list());

  //port = new Serial(this, "COM1", 9600);
  // Uses the first available port
  port = new Serial(this, Serial.list()[0], 9600);
  
  
  cols = new color[colors];
  cols[0] = color(255, 0, 0);
  cols[1] = color(0, 255, 0);
  cols[2] = color(0, 0, 255);
  
  Values = new HScrollbar[colors];
  Frequ = new HScrollbar[colors];
  angles = new float[colors];
  modes = new int[colors];
  
  
  for (int c = 0; c < colors; c++) {
    angles[c] = 0.0;
    Values[c] = new HScrollbar(0, 30 + c*50, 254, 30, cols[c]);
    Frequ[c] = new HScrollbar(300, 30 + c*50, 200, 30, cols[c]);
    Frequ[c].setPos(0);
    modes[c] = mode_sin2;
  }
}

void draw()
{
  background(100);
  
  port.write(255);
  for (int c = 0; c < colors; c++) {
    Values[c].update();
    Values[c].draw();
    Frequ[c].update();
    Frequ[c].draw();
    if (Frequ[c].getPos() < 0.1) {
      port.write((byte)Values[c].getPos());
      angles[c] = 0.0;
    }
    else {
      if (modes[c] == mode_sin)
      {
          val = (Values[c].getPos() * (cos(angles[c])+1)/2.0);
      }
      else 
      {
         val = cos(angles[c]);
          if (val < 0)
            val = 0;
          val *= Values[c].getPos();
      }
      port.write((byte)val);
      angles[c] += exp((Frequ[c].getPos()-200)/50.0);
      if (angles[c] > 2*PI) {
        angles[c] -= 2*PI;
      }
    } 
  }
}



class HScrollbar
{
  int swidth, sheight;    // width and height of bar
  int xpos, ypos;         // x and y position of bar
  float spos, newspos;    // x position of slider
  int sposMin, sposMax;   // max and min values of slider
  boolean over;           // is the mouse over the slider?
  boolean locked;
  float ratio;
  color col;

  HScrollbar (int xp, int yp, int sw, int sh, color ccol) {
    swidth = sw;
    sheight = sh;
    int widthtoheight = sw - sh;
    ratio = (float)sw / (float)widthtoheight;
    xpos = xp;
    ypos = yp-sheight/2;
    spos = xpos + swidth/2 - sheight/2;
    newspos = spos;
    sposMin = xpos;
    sposMax = xpos + swidth - sheight;
    col = ccol;
  }

  void update() {
    if(over()) {
      over = true;
    } else {
      over = false;
    }
    if(mousePressed && over) {
      locked = true;
    }
    if(!mousePressed) {
      locked = false;
    }
    if(locked) {
      spos = constrain(mouseX-sheight/2, sposMin, sposMax);
    }
  }

  int constrain(int val, int minv, int maxv) {
    return min(max(val, minv), maxv);
  }

  boolean over() {
    if(mouseX > xpos && mouseX < xpos+swidth &&
    mouseY > ypos && mouseY < ypos+sheight) {
      return true;
    } else {
      return false;
    }
  }

  void draw() {
    fill(col);
    rect(xpos, ypos, swidth, sheight);
    if(over || locked) {
      fill(255);
    } else {
      fill(150);
    }
    rect(spos, ypos, sheight, sheight);
  }

  float getPos() {
    // convert spos to be values between
    // 0 and the total width of the scrollbar
    return (spos-sposMin) * ratio;
  }
  
  void setPos(float  val) {
    spos = sposMin + val / ratio;
  }
}
